<?php

function UpdateTo493($Manager)
{      
  $Manager->Execute("ALTER TABLE `UserOnline` CHANGE `User` `User` INT( 11 ) NULL DEFAULT NULL COMMENT 'User.Id'");
}

function UpdateTo494($Manager)
{      
  $Manager->Execute("ALTER TABLE `FinanceOperation` DROP FOREIGN KEY `FinanceOperation_ibfk_2` ;\n".
    "ALTER TABLE `FinanceOperation` CHANGE `Bill` `File` INT( 11 ) NULL DEFAULT NULL;\n".
    "ALTER TABLE `FinanceOperation` ADD FOREIGN KEY ( `File` ) REFERENCES `File` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
}

function UpdateTo495($Manager)
{
  $Manager->Execute("INSERT INTO `MapPosition` (SELECT NULL AS `Id`, `Name`, `MapPositionX` AS `Latitude`, `MapPositionY` AS `Longitude` FROM `Subject`)");
  $Manager->Execute("ALTER TABLE `Subject` ADD `MapPosition` INT NULL AFTER `PayVAT`");
  $Manager->Execute("UPDATE `Subject` SET `MapPosition` = (SELECT `MapPosition`.`Id` FROM `MapPosition` WHERE `MapPosition`.`Name` = `Subject`.`Name` LIMIT 1)");
  $Manager->Execute("ALTER TABLE `Subject`  DROP `MapPositionX`,  DROP `MapPositionY`;");
  $Manager->Execute("ALTER TABLE `Subject` ADD INDEX ( `MapPosition` ) ");
  $Manager->Execute("ALTER TABLE `Subject` ADD FOREIGN KEY ( `MapPosition` ) REFERENCES `MapPosition` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
}

function UpdateTo497($Manager)
{
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD `Id` INT NOT NULL AUTO_INCREMENT FIRST , ADD PRIMARY KEY ( `Id` ) ");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD `ReplaceId` INT NULL ,ADD INDEX ( `ReplaceId` ) ");
  $Manager->Execute("DELETE FROM `FinanceCharge` WHERE `FinanceCharge`.`Period` = 1");
  $Manager->Execute("ALTER TABLE `FinanceCharge` DROP `Period`");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD `Action` ENUM( 'add', 'modify', 'remove' ) NULL AFTER `TopTariffPrice` ");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD FOREIGN KEY ( `ReplaceId` ) REFERENCES `FinanceCharge` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD INDEX ( `Action` )");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Parametry účtování', '2', 'FinanceCharge', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Úseky sítě', '2', 'NetworkSegment', '');");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD `Action` ENUM( 'add', 'modify', 'remove' ) NULL , ".
    "ADD `ReplaceId` INT NULL");
  $Manager->Execute("DELETE FROM `ServiceCustomerRel` WHERE `Period`=1");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` DROP `Period`");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD INDEX ( `Action` )");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD INDEX ( `ReplaceId` ) ");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD FOREIGN KEY ( `ReplaceId` ) REFERENCES `ServiceCustomerRel` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `Service` ADD `Action` ENUM( 'add', 'modify', 'remove' ) NULL AFTER `CustomerCount`");
  $Manager->Execute("ALTER TABLE `Service` ADD INDEX ( `Action` )");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Placení zákazníků', '2', 'MemberPayment', '');");
}

function UpdateTo498($Manager)
{
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Síťové služby', '1', 'NetworkConfiguration', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Fronta e-mailů', '23', 'EmailQueue', '');");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `FinanceVAT` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  `ValidFrom` date NOT NULL,
  `Value` int(11) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
INSERT INTO `FinanceVAT` (`Id`, `Name`, `ValidFrom`, `Value`) VALUES
(1, 'DPH snížená sazba', '2013-01-01', 15),
(2, 'DPH běžná sazba', '2013-01-01', 21);");
  $Manager->Execute("ALTER TABLE `Service` ADD `VAT` INT NOT NULL AFTER `Price`");
  $Manager->Execute("ALTER TABLE `Service` ADD INDEX ( `VAT` ) ");
  $Manager->Execute("UPDATE `Service` SET `VAT` = 2;");
  $Manager->Execute("ALTER TABLE `Service` ADD FOREIGN KEY ( `VAT` ) REFERENCES `FinanceVAT` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `FinanceInvoice` ADD `Cash` INT NOT NULL DEFAULT '0'");
}

function UpdateTo499($Manager)
{
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `Currency` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Code` varchar(3) NOT NULL,
  `Name` varchar(255) NOT NULL,
  `Symbol` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

INSERT INTO `Currency` (`Id`, `Code`, `Name`, `Symbol`) VALUES
(1, 'CZK', 'Česká koruna', 'Kč'),
(2, 'EUR', 'Euro', '€'),
(3, 'USD', 'Americký dolar', '$'),
(4, 'CNY', 'Čínský jüan', '¥');");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `FinanceBankImport` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `BankAccount` int(11) NOT NULL,
  `Time` date NOT NULL,
  `Identification` varchar(255) NOT NULL,
  `AccountNumber` varchar(255) NOT NULL,
  `VariableSymbol` varchar(255) NOT NULL,
  `ConstantSymbol` varchar(255) NOT NULL,
  `SpecificSymbol` varchar(255) NOT NULL,
  `Value` decimal(10,0) NOT NULL,
  `Currency` int(11) NOT NULL,
  `Description` varchar(255) NOT NULL,
  `OffsetAccountName` varchar(255) NOT NULL,
  `FinanceOperation` int(11) DEFAULT NULL,
  PRIMARY KEY (`Id`),
  KEY `FinanceOperation` (`FinanceOperation`),
  KEY `Currency` (`Currency`),
  KEY `BankAccount` (`BankAccount`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE `FinanceBankImport`
  ADD CONSTRAINT `FinanceBankImport_ibfk_3` FOREIGN KEY (`FinanceOperation`) REFERENCES `FinanceOperation` (`Id`),
  ADD CONSTRAINT `FinanceBankImport_ibfk_1` FOREIGN KEY (`BankAccount`) REFERENCES `FinanceBankAccount` (`Id`),
  ADD CONSTRAINT `FinanceBankImport_ibfk_2` FOREIGN KEY (`Currency`) REFERENCES `Currency` (`Id`);");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`)".
  "VALUES (NULL , 'Měny', '2', 'Currency', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Import z účtu', '2', 'FinanceBankImport', '');");
}

function UpdateTo500($Manager)
{
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `FinanceBank` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  `Code` varchar(4) NOT NULL,
  `BIC` varchar(255) NOT NULL,
  `Country` int(11) NOT NULL,
  PRIMARY KEY (`Id`),
  KEY `Country` (`Country`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("ALTER TABLE `FinanceBank`
  ADD CONSTRAINT `FinanceBank_ibfk_1` FOREIGN KEY (`Country`) REFERENCES `Country` (`Id`);");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `Bank` INT NOT NULL AFTER `Number` ,".
     " ADD INDEX ( `Bank` )");
  $Manager->Execute("INSERT INTO `FinanceBank` (`Id`, `Name`, `Code`, `BIC`, `Country`) VALUES
  (1, 'Neznámá banka', '', '', 1);");
  $Manager->Execute("UPDATE `FinanceBankAccount` SET `Bank` = 1 WHERE `Bank` = 0");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD FOREIGN KEY ( `Bank` ) REFERENCES `FinanceBank` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Banky', '2', 'FinanceBank', '');");
}

function UpdateTo502($Manager)
{
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `LoginName` VARCHAR( 255 ) NOT NULL ");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `LoginPassword` VARCHAR( 255 ) NOT NULL");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `Currency` INT NOT NULL AFTER `Use` ,".
    "ADD INDEX ( `Currency` ) ");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Banka', '2', '', '');");
  $Id = $Manager->Database->insert_id;
  $Manager->Execute("UPDATE `ISMenuItem` SET `Parent` = '".$Id."' WHERE `ISMenuItem`.`Id` ='Bankovní účty'; ".
    "UPDATE `ISMenuItem` SET `Parent` = '".$Id."' WHERE `ISMenuItem`.`Id` ='Import z účtu';".
    "UPDATE `ISMenuItem` SET `Parent` = '".$Id."' WHERE `ISMenuItem`.`Name` ='Banky';");
}

function UpdateTo505($Manager)
{
  $Manager->Execute("UPDATE `ISMenuItem` SET `Name` = 'Služby', `Table` = 'Service' WHERE `ISMenuItem`.`Name` ='Tarify';");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
      "VALUES (NULL , 'Kategorie služeb', '2', 'ServiceCategory', '');");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `NetworkShareItem` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL DEFAULT '',
  `Parent` int(11) NOT NULL DEFAULT '0',
  `Host` int(11) NOT NULL DEFAULT '0',
  `Size` bigint(20) NOT NULL DEFAULT '0',
  `Ext` varchar(64) NOT NULL DEFAULT '',
  `Date` date NOT NULL DEFAULT '0000-00-00',
  `Type` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`Id`),
  KEY `Parent` (`Parent`),
  KEY `Search` (`Name`,`Size`),
  KEY `Name` (`Name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `NetworkShareError` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Host` varchar(16) NOT NULL DEFAULT '',
  `Message` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;"); 
}

function UpdateTo507($Manager)
{
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Aktuality', NULL, '', '');");
  $Id = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Aktuality', '".$Id."', 'News', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Kategorie aktualit', '".$Id."', 'NewsCategory', '');");
  $Manager->Execute("INSERT INTO `FileDirectory` (`Id` ,`Name` ,`Parent`".
    ") VALUES (NULL , 'news', NULL);");
  $Manager->Execute("ALTER TABLE `File` ADD `Time` DATETIME NOT NULL ");
  // Convert Hire column to Service item
  $Manager->Execute("INSERT INTO `ServiceCategory` (
`Id` ,`Name`) VALUES (NULL , 'Pevný nájem');");
  $ServiceCategoryHire = $Manager->Database->insert_id;  
  $DbResult = $Manager->Execute("SELECT * FROM Member WHERE Hire>0");
  while($Member = $DbResult->fetch_assoc())
  {
    $Manager->Execute("INSERT INTO `Service` (
`Id` ,`Name` ,`Category` ,`Price` ,`VAT` ,`CustomerCount` ,`Action` ,`ReplaceId` ,
`Public` ,`InternetSpeedMin` ,`InternetSpeedMax` ,`UploadAsymmetry` ,`Memory` ,`MemorySwap` ,`Storage` ,`CPUCount`)
VALUES (
NULL , 'Nájem', '".$ServiceCategoryHire."', '-".$Member['Hire']."', '2', '', NULL , NULL , '', '', '', '', '', '', '', ''
);");
    $ServiceHire = $Manager->Database->insert_id;  
    $Manager->Execute("INSERT INTO `ServiceCustomerRel` (`Service`, `Customer`) VALUES ". 
      "(".$ServiceHire.",".$Member['Id'].")");
  }
  $Manager->Execute("ALTER TABLE `Member` DROP `Hire`");
  // Each device and subnet have to be assigned to payed service to determine service parameters
  $Manager->Execute("ALTER TABLE `NetworkDevice` ADD `Service` INT NULL AFTER `Location` ,
ADD INDEX ( `Service` )");
  $Manager->Execute("ALTER TABLE `NetworkDevice` ADD FOREIGN KEY ( `Service` ) REFERENCES `ServiceCustomerRel` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("UPDATE `NetworkDevice` SET `Service` = (SELECT `Id` FROM `ServiceCustomerRel` WHERE `ServiceCustomerRel`.`Customer` = `NetworkDevice`.`Member` LIMIT 1)");
  $Manager->Execute("ALTER TABLE `NetworkSubnet` ADD `Service` INT NULL AFTER `Member` ,
ADD INDEX ( `Service` ) ");
  $Manager->Execute("ALTER TABLE `NetworkSubnet` ADD FOREIGN KEY ( `Service` ) REFERENCES `ServiceCustomerRel` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("UPDATE `NetworkSubnet` SET `Service` = (SELECT `Id` FROM `ServiceCustomerRel` WHERE `ServiceCustomerRel`.`Customer` = `NetworkSubnet`.`Member` LIMIT 1)"); 
}

function UpdateTo515($Manager)
{
  $Manager->Execute("ALTER TABLE `PermissionUserAssignment` CHANGE `User` `User` INT( 11 ) NULL");
}

function UpdateTo517($Manager)
{
  $Manager->Execute("ALTER TABLE `Log` ADD `IPAddress` VARCHAR( 16 ) NOT NULL");
}

function UpdateTo526($Manager)
{
  $Manager->Execute("ALTER TABLE `Hyperlink` CHANGE `Name` `Title` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL");
  $Manager->Execute("ALTER TABLE `Hyperlink` ADD `Name` VARCHAR( 255 ) NOT NULL AFTER `Id`");
  //$Manager->Execute("ALTER TABLE `Hyperlink` ADD UNIQUE ( `Name` )");
  $Manager->Execute("ALTER TABLE `Hyperlink` ADD `Type` INT NOT NULL AFTER `Title` , ADD INDEX ( `Type` )");
  $Manager->Execute("RENAME TABLE `Hyperlink` TO `Action` ;");
  $Manager->Execute("RENAME TABLE `HyperlinkGroup` TO `ActionGroup` ;");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `ActionType` (
      `Id` int(11) NOT NULL AUTO_INCREMENT,
      `Name` varchar(255) NOT NULL,
      PRIMARY KEY (`Id`)
  ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;
  
  INSERT INTO `ActionType` (`Id`, `Name`) VALUES
  (1, 'Odkaz'),
  (2, 'Obrázek');");
  $Manager->Execute("UPDATE `Action` SET `Type` = 1;");
  $Manager->Execute("ALTER TABLE `Action` ADD FOREIGN KEY ( `Type` ) REFERENCES `ActionType` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("UPDATE `Panel` SET `Module` = 'ActionGroup' WHERE `Module` = 'HyperlinkGroup'");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `ActionIcon` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("INSERT INTO `ActionIcon` (SELECT NULL AS `Id`, `IconFile` AS `Name` FROM `Action` WHERE `IconFile` != '' GROUP BY `IconFile`)");
  $Manager->Execute("ALTER TABLE `Action` CHANGE `IconFile` `IconFile` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
  $Manager->Execute("UPDATE `Action` SET `IconFile` = (SELECT `Id` FROM `ActionIcon` WHERE `ActionIcon`.`Name` = `Action`.`IconFile`) ");
  $Manager->Execute("ALTER TABLE `Action` CHANGE `IconFile` `Icon` INT NULL ");
  $Manager->Execute("UPDATE `Action` SET `Icon` = NULL WHERE `Icon` = 0");
  $Manager->Execute("ALTER TABLE `Action` ADD INDEX ( `Icon` ) ");
  $Manager->Execute("ALTER TABLE `Action` ADD FOREIGN KEY ( `Icon` ) REFERENCES `ActionIcon` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Akce', '23', 'Action', '');");
}

function UpdateTo527($Manager)
{
  $Manager->Execute("RENAME TABLE `ISMenuItem` TO `MenuItem` ;");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `Menu` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("INSERT INTO `Menu` (`Id` ,`Name`)VALUES (NULL , 'IS');");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD `Menu` INT NOT NULL , ADD INDEX ( `Menu` )");
  $Manager->Execute("UPDATE `MenuItem` SET `Menu` = 1");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD FOREIGN KEY ( `Menu` ) REFERENCES `Menu` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `Action` CHANGE `Group` `Group` INT( 11 ) NULL ");
  $Manager->Execute("INSERT INTO `Action` (SELECT NULL AS `Id`, '' AS `Name`, `Name` AS `Title`, 1 AS `Type`, CONCAT('/is/?t=', `Table`, '&a=list') AS `URL`, NULL AS `Group`, NULL AS `Icon`, NULL AS `PermisionModule`,  NULL AS `PermissionOperation`, 1 AS `Enable` FROM `MenuItem` WHERE `Parent` IS NOT NULL)");
  $Manager->Execute("ALTER TABLE `MenuItem` DROP `IconName`");
  $Manager->Execute("UPDATE `MenuItem` SET `Table` = (SELECT `Id` FROM `Action` WHERE `Action`.`URL` = CONCAT('/is/?t=', `MenuItem`.`Table`, '&a=list')) WHERE `MenuItem`.`Table` != ''");
  $Manager->Execute("ALTER TABLE `MenuItem` CHANGE `Table` `Action` INT NULL");
  $Manager->Execute("UPDATE `MenuItem` SET `Action` = NULL WHERE `Action` = 0");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD INDEX ( `Action` ) ");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD FOREIGN KEY ( `Action` ) REFERENCES `Action` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("INSERT INTO `Action` (`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionModule` ,`PermissionOperation` ,`Enable`)".
    "VALUES (NULL , '', 'Nabídky', '1', '/is/?t=Menu&a=list', NULL , NULL , '', '', '1');");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Nabídky', '23', '".$ActionId."', '1');");  
}

function UpdateTo535($Manager)
{
  // Set all string collation to utf8 general
  $DbResult = $Manager->Execute("SHOW TABLES");
  while($DbRow = $DbResult->fetch_row())
  {
    $Manager->Execute("ALTER TABLE `".$DbRow[0]."` CONVERT TO CHARACTER SET utf8"); 
  }  
}

function UpdateTo549($Manager)
{
  $Manager->Execute("ALTER TABLE `FinanceOperation` ADD `Generate` INT NOT NULL DEFAULT '0',
ADD INDEX ( `Generate` ) ;");
  $Manager->Execute("ALTER TABLE `FinanceInvoice` ADD `Generate` INT NOT NULL DEFAULT '0',
ADD INDEX ( `Generate` ) ;");
}

function UpdateTo550($Manager)
{  
  $Manager->Execute('ALTER TABLE `FinanceBankAccount` ADD `LastImportId` VARCHAR( 255 ) NOT NULL ;');
  $Manager->Execute('ALTER TABLE `FinanceBankAccount` ADD `LastImportDate` DATE NULL ;');
  $Manager->Execute('ALTER TABLE `FinanceBankImport` ADD `BankCode` VARCHAR( 255 ) NOT NULL AFTER `AccountNumber` ;');
}

function UpdateTo551($Manager)
{  
  $Manager->Execute('ALTER TABLE `FinanceOperation` ADD `DocumentLine` INT NULL AFTER `Value` ,
ADD INDEX ( `DocumentLine` ) ;');
  $Manager->Execute('ALTER TABLE `FinanceOperation` ADD FOREIGN KEY ( `DocumentLine` ) REFERENCES `DocumentLine` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;');
  $Manager->Execute('ALTER TABLE `FinanceInvoice` ADD `DocumentLine` INT NULL AFTER `Id` ,
ADD INDEX ( `DocumentLine` ) ;');
  $Manager->Execute('ALTER TABLE `FinanceInvoice` ADD FOREIGN KEY ( `DocumentLine` ) REFERENCES `DocumentLine` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;');
  $Manager->Execute('DROP TABLE `FinanceBillsItemsOld`');
  $Manager->Execute('DROP TABLE `FinanceBillsOld`');
}

function UpdateTo565($Manager)
{  
  $Manager->Execute('CREATE TABLE IF NOT EXISTS `WikiPage` (
    `Id` int(11) NOT NULL AUTO_INCREMENT,
    `Name` varchar(255) NOT NULL,
    `NormalizedName` varchar(255) NOT NULL,
    `VisibleInMenu` int(11) NOT NULL,
    PRIMARY KEY (`Id`),
    UNIQUE KEY `Name` (`Name`),
    KEY `VisibleInMenu` (`VisibleInMenu`)
    ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;');
  $Manager->Execute('CREATE TABLE IF NOT EXISTS `WikiPageContent` (
    `Id` int(11) NOT NULL AUTO_INCREMENT,
    `Page` int(11) NOT NULL,
    `Time` datetime NOT NULL,
    `Content` text NOT NULL,
    `User` int(11) NOT NULL,
    PRIMARY KEY (`Id`),
    KEY `User` (`User`),
        KEY `Page` (`Page`)
    ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;');
    $Manager->Execute('ALTER TABLE `WikiPageContent`
    ADD CONSTRAINT `WikiPageContent_ibfk_2` FOREIGN KEY (`Page`) REFERENCES `WikiPage` (`Id`),
ADD CONSTRAINT `WikiPageContent_ibfk_1` FOREIGN KEY (`User`) REFERENCES `User` (`ID`);');
}

function UpdateTo571($Manager)
{  
  $Manager->Execute('ALTER TABLE `NetworkDevice` ADD `LoginName` VARCHAR( 255 ) NOT NULL ,
ADD `LoginPassword` VARCHAR( 255 ) NOT NULL ;');
}

function UpdateTo574($Manager)
{
  $Manager->Execute('ALTER TABLE `MapPosition` ADD `Pos` VARCHAR( 255 ) NOT NULL ;');
  $Manager->Execute('UPDATE `MapPosition` SET `Pos`=CONCAT(`Latitude`, ";", `Longitude`)');
  $Manager->Execute('ALTER TABLE `MapPosition` DROP `Latitude`');
  $Manager->Execute('ALTER TABLE `MapPosition` DROP `Longitude`');
}

function UpdateTo584($Manager)
{
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `Module` (
      `Id` int(11) NOT NULL AUTO_INCREMENT,
      `Name` varchar(255) NOT NULL,
      `Title` varchar(255) NOT NULL,
      PRIMARY KEY (`Id`)
  ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=33 ;");
  
  $Manager->Execute("INSERT INTO `Module` (`Id`, `Name`, `Title`) VALUES
  (1, 'Customer', 'Zákazník'),
  (2, 'EmailQueue', 'Fronta emailů'),
  (3, 'Error', 'Obsluha chyb'),
  (4, 'File', 'Správa souborů'),
  (5, 'Finance', 'Finance'),
  (6, 'FinanceBankAPI', 'Rozhraní pro bankovní účty'),
  (7, 'Chat', 'Pokec'),
  (8, 'IS', 'Informační systém'),
  (9, 'Log', 'Záznam událostí'),
  (10, 'Map', 'Mapa'),
  (11, 'Meals', 'Jídelníček'),
  (12, 'Meteostation', 'Meteostanice'),
  (13, 'Network', 'Síť'),
  (14, 'NetworkConfig', 'Nastavení sítě'),
  (15, 'NetworkConfigLinux', 'Nastavení linuxových zařízení'),
  (16, 'NetworkConfigRouterOS', 'Nastavení RouterOS zařízení'),
  (17, 'NetworkShare', 'Síťové sdílení'),
  (18, 'NetworkTopology', 'Síťová topologie'),
  (19, 'News', 'Aktuality'),
  (20, 'OpeningHours', 'Otvírací doby'),
  (21, 'Portal', 'Portál'),
  (22, 'Search', 'Vyhledávání'),
  (23, 'Setup', 'Instalace systému'),
  (24, 'SpeedTest', 'Měření rychlosti'),
  (25, 'Stock', 'Sklad'),
  (26, 'System', 'Systém'),
  (27, 'Task', 'Úlohy'),
  (28, 'TimeMeasure', 'Časové průběhy'),
  (29, 'TV', 'Televize'),
  (30, 'User', 'Uživatelé'),
  (31, 'WebCam', 'Web kamery'),
  (32, 'Wiki', 'Wiki');");
  $Manager->Execute("UPDATE `PermissionOperation` SET `Module` = 'Meals' WHERE `PermissionOperation`.`Module` ='EatingPlace';");
  $Manager->Execute("UPDATE `PermissionOperation` SET `Module` = 'NetworkShare' WHERE `PermissionOperation`.`Module` ='Share';");
  $Manager->Execute("UPDATE `PermissionOperation` SET `Module` = 'OpeningHours' WHERE `PermissionOperation`.`Module` ='SubjectOpenTime';");
  $Manager->Execute("UPDATE `PermissionOperation` SET `Module`=(SELECT `Id` FROM `Module` WHERE `Module`.`Name` = `PermissionOperation`.`Module`)");
  $Manager->Execute("ALTER TABLE `PermissionOperation` CHANGE `Module` `Module` INT( 11 ) NOT NULL ;");
  $Manager->Execute("ALTER TABLE `PermissionOperation` ADD FOREIGN KEY ( `Module` ) REFERENCES `Module` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("UPDATE `Action` SET `Action`.`PermissionOperation` =(SELECT Id FROM `PermissionOperation` WHERE `PermissionOperation`.`Operation`=`Action`.`PermissionOperation` AND `PermissionOperation`.`Module` = (SELECT Id FROM `Module` WHERE `Module`.`Name`=`Action`.`PermissionModule`))");
  $Manager->Execute("ALTER TABLE `Action` CHANGE `PermissionOperation` `PermissionOperation` INT( 11 ) NULL ;");
  $Manager->Execute("ALTER TABLE `Action` DROP `PermissionModule` ;");
  $Manager->Execute("UPDATE `Action` SET `PermissionOperation`=NULL WHERE `PermissionOperation`=0");
  $Manager->Execute("ALTER TABLE `Action` ADD INDEX (`PermissionOperation`);");
  $Manager->Execute("ALTER TABLE `Action` ADD FOREIGN KEY ( `PermissionOperation` ) REFERENCES `PermissionOperation` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
}

function UpdateTo591($Manager)
{
  $Manager->Execute('ALTER TABLE `StockItem` ADD `Esemble` INT NULL ,
ADD INDEX ( `Esemble` ) ;');
  $Manager->Execute('ALTER TABLE `StockItem` ADD FOREIGN KEY ( `Esemble` ) REFERENCES `StockItem` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;');
}

function UpdateTo597($Manager)
{
  $Manager->Execute('CREATE TABLE IF NOT EXISTS `Model` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  `Module` int(11) NOT NULL,
  PRIMARY KEY (`Id`),
  KEY `Module` (`Module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;');

  $Manager->Execute('ALTER TABLE `Model`
  ADD CONSTRAINT `Model_ibfk_1` FOREIGN KEY (`Module`) REFERENCES `Module` (`Id`);');
}

function UpdateTo601($Manager)
{
  $Manager->Execute('CREATE TABLE IF NOT EXISTS `NetworkInterfaceWireless` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `NetworkInterface` int(11) NOT NULL,
  `TxPower` int(11) NOT NULL,
  `CableAttenuation` int(11) NOT NULL,
  `AntenaGain` int(11) NOT NULL,
  `Frequency` float NOT NULL,
  `ChannelWidth` int(11) NOT NULL,
  `SSID` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`),
  KEY `NetworkInterface` (`NetworkInterface`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;');

  $Manager->Execute('ALTER TABLE `NetworkInterfaceWireless`
  ADD CONSTRAINT `NetworkInterfaceWireless_ibfk_1` FOREIGN KEY (`NetworkInterface`) REFERENCES `NetworkInterface` (`Id`);');
  $Manager->Execute("INSERT INTO `Action` (
`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionOperation` ,
`Enable`) VALUES (NULL , '', 'Wifi rozhraní', '1', '/is/?t=NetworkInterfaceWireless&a=list', NULL , NULL , NULL , '1'
);");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Bezdrátové rozhraní', '1', '".$ActionId."', '1');");
}

function UpdateTo615($Manager)
{
  $Manager->Execute('ALTER TABLE `NetworkInterfaceWireless` ADD `AntennaPolarity` INT NOT NULL ,
ADD `Description` VARCHAR( 255 ) NOT NULL ;');
  $Manager->Execute('CREATE TABLE IF NOT EXISTS `NewsImport` (
  `Id` int(11) NOT NULL,
  `Name` varchar(255) NOT NULL,
  `Enabled` int(11) NOT NULL,
  `Source` varchar(255) NOT NULL,
  `Category` int(11) NOT NULL,
  `BlockStart` varchar(255) NOT NULL,
  `BlockEnd` varchar(255) NOT NULL,
  `ItemStart` varchar(255) NOT NULL,
  `ItemEnd` varchar(255) NOT NULL,
  `TitleStart` varchar(255) NOT NULL,
  `TitleEnd` varchar(255) NOT NULL,
  `ContentStart` varchar(255) NOT NULL,
  `ContentEnd` varchar(255) NOT NULL,
  `LinkStart` varchar(255) NOT NULL,
  `LinkEnd` varchar(255) NOT NULL,
  `DateStart` varchar(255) NOT NULL,
  `DateEnd` varchar(255) NOT NULL,
  KEY `Category` (`Category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;');
  $Manager->Execute('ALTER TABLE `NewsImport` '.
    'ADD CONSTRAINT `NewsImport_ibfk_1` FOREIGN KEY (`Category`) '.
    ' REFERENCES `NewsCategory` (`Id`);');
  $Manager->Execute('ALTER TABLE `NetworkInterfaceWireless` ADD `Antenna` INT NULL AFTER `AntennaPolarity` ,
ADD INDEX ( `Product` ) ;');
  $Manager->Execute('ALTER TABLE `NetworkInterfaceWireless` ADD FOREIGN KEY ( `Antenna` ) REFERENCES `Product` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;');
  $Manager->Execute('ALTER TABLE `NetworkInterfaceWireless` ADD `MAC` VARCHAR( 17 ) NOT NULL ;');
}

function UpdateTo619($Manager)
{
  $Manager->Execute('ALTER TABLE `UserOnline` ADD `StayLogged` INT NOT NULL ;');
}

function UpdateTo620($Manager)
{
  $Manager->Execute('ALTER TABLE `NetworkInterfaceWireless` ADD `ChannelWidthLower` INT NOT NULL ,
ADD `ChannelWidthUpper` INT NOT NULL ;');
  $Manager->Execute('ALTER TABLE `NetworkInterfaceWireless` ADD `Mode` INT NOT NULL ;');
  $Manager->Execute('DROP TABLE `NetworkAP`');
}

function UpdateTo627($Manager)
{
	$Manager->Execute('ALTER TABLE `FinanceInvoice` CHANGE `TimeCreation` `Time` DATETIME NOT NULL DEFAULT "0000-00-00 00:00:00";');
	$Manager->Execute('ALTER TABLE `FinanceYear` ADD `Closed` INT NOT NULL ;');
}

function UpdateTo632($Manager)
{
	$Manager->Execute('CREATE TABLE IF NOT EXISTS `FinanceInvoiceOperationRel` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Invoice` int(11) NOT NULL,
  `Operation` int(11) NOT NULL,
  PRIMARY KEY (`Id`),
  KEY `Invoice` (`Invoice`),
  KEY `Operation` (`Operation`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;');
  $Manager->Execute('ALTER TABLE `FinanceInvoiceOperationRel`
  ADD CONSTRAINT `FinanceInvoiceOperationRel_ibfk_2` FOREIGN KEY (`Operation`) REFERENCES `FinanceOperation` (`Id`),
  ADD CONSTRAINT `FinanceInvoiceOperationRel_ibfk_1` FOREIGN KEY (`Invoice`) REFERENCES `FinanceInvoice` (`Id`);');
}

function UpdateTo633($Manager)
{
	$Manager->Execute('ALTER TABLE `UserOnline` ADD `StayLoggedHash` VARCHAR( 40 ) NOT NULL ;');
}

function UpdateTo645($Manager)
{
	$Manager->Execute('CREATE TABLE IF NOT EXISTS `FinanceVATType` (
  `Id` int(11) NOT NULL,
  `Name` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;');
  $Manager->Execute('INSERT INTO `FinanceVATType` FROM (SELECT Id, Name FROM `FinanceVAT`)');
  $Manager->Execute('ALTER TABLE `FinanceVAT` ADD `ValidTo` DATE NULL ,
ADD `Type` INT NOT NULL ;');
  $Manager->Execute('UPDATE `FinanceVAT` SET `Type`=(SELECT `Id` FROM `FinanceVATType` WHERE `FinanceVATType`.`Name`=`FinanceVAT`.`Name`)');
  $Manager->Execute('ALTER TABLE `FinanceVAT` DROP `Name`');
}

function UpdateTo646($Manager)
{
	$Manager->Execute('CREATE TABLE IF NOT EXISTS `Contract` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `BillCode` varchar(255) NOT NULL,
  `Subject` int(11) NOT NULL,
  `DocumentLine` int(11) NOT NULL,
  `ValidFrom` date NOT NULL,
  `ValidTo` date DEFAULT NULL,
  `File` int(11) DEFAULT NULL,
  PRIMARY KEY (`Id`),
  KEY `Subject` (`Subject`),
  KEY `DocumentLine` (`DocumentLine`),
  KEY `File` (`File`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;');
  $Manager->Execute('ALTER TABLE `Contract`
  ADD CONSTRAINT `Contract_ibfk_3` FOREIGN KEY (`File`) REFERENCES `File` (`Id`),
  ADD CONSTRAINT `Contract_ibfk_1` FOREIGN KEY (`Subject`) REFERENCES `Subject` (`Id`),
  ADD CONSTRAINT `Contract_ibfk_2` FOREIGN KEY (`DocumentLine`) REFERENCES `DocumentLine` (`Id`);
');
  $Manager->Execute("INSERT INTO `Action` (
`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionOperation` ,
`Enable`) VALUES (NULL , '', 'Smlouvy', '1', '/is/?t=Contract&a=list', NULL , NULL , NULL , '1'
);");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Smlouvy', '2', '".$ActionId."', '1');");
  $Manager->Execute("INSERT INTO `Action` (
`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionOperation` ,
`Enable`) VALUES (NULL , '', 'Sazby DPH', '1', '/is/?t=FinanceVAT&a=list', NULL , NULL , NULL , '1'
);");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Sazby DPH', '2', '".$ActionId."', '1');");
}

function UpdateTo647($Manager)
{
	$Manager->Execute('ALTER TABLE `EmployeeSalary` ADD FOREIGN KEY ( `Employee` ) REFERENCES `Employee` (
`Id`
) ON DELETE RESTRICT ON UPDATE RESTRICT ;');
  $Manager->Execute('ALTER TABLE `EmployeeSalary` ADD `Contract` INT NOT NULL ,
ADD INDEX ( `Contract` ) ;');
 $Manager->Execute('ALTER TABLE `EmployeeSalary` ADD FOREIGN KEY ( `Contract` ) REFERENCES `Contract` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;');
  $Manager->Execute("INSERT INTO `Action` (
`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionOperation` ,
`Enable`) VALUES (NULL , '', 'Zaměstnanci', '1', '/is/?t=Employee&a=list', NULL , NULL , NULL , '1'
);");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Zaměstnanci', '2', '".$ActionId."', '1');");
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Roční výkazy', '2', NULL, '1');");
  $MenuId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `Action` (
`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionOperation` ,
`Enable`) VALUES (NULL , '', 'Roční přehled', '1', '/is/?t=FinanceYearReport&a=list', NULL , NULL , NULL , '1'
);");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Roční přehled', '".$MenuId."', '".$ActionId."', '1');");
  $Manager->Execute("INSERT INTO `Action` (
`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionOperation` ,
`Enable`) VALUES (NULL , '', 'Výkaz subjektů', '1', '/is/?t=SubjectReport&a=list', NULL , NULL , NULL , '1'
);");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Výkaz subjektů', '".$MenuId."', '".$ActionId."', '1');");
}


class Updates
{
  function Get()
  {
    return(array(
      491 => array('Revision' => 493, 'Function' => 'UpdateTo493'),
      493 => array('Revision' => 494, 'Function' => 'UpdateTo494'),
      494 => array('Revision' => 495, 'Function' => 'UpdateTo495'),
      495 => array('Revision' => 497, 'Function' => 'UpdateTo497'),
      497 => array('Revision' => 498, 'Function' => 'UpdateTo498'),
      498 => array('Revision' => 499, 'Function' => 'UpdateTo499'),
      499 => array('Revision' => 500, 'Function' => 'UpdateTo500'),
      500 => array('Revision' => 502, 'Function' => 'UpdateTo502'),
      502 => array('Revision' => 505, 'Function' => 'UpdateTo505'),
      505 => array('Revision' => 507, 'Function' => 'UpdateTo507'),
      507 => array('Revision' => 515, 'Function' => 'UpdateTo515'),
      515 => array('Revision' => 517, 'Function' => 'UpdateTo517'),
      517 => array('Revision' => 526, 'Function' => 'UpdateTo526'),
      526 => array('Revision' => 527, 'Function' => 'UpdateTo527'),
      527 => array('Revision' => 535, 'Function' => 'UpdateTo535'),
      535 => array('Revision' => 549, 'Function' => 'UpdateTo549'),
      549 => array('Revision' => 550, 'Function' => 'UpdateTo550'),
      550 => array('Revision' => 551, 'Function' => 'UpdateTo551'),
      551 => array('Revision' => 565, 'Function' => 'UpdateTo565'),
      565 => array('Revision' => 571, 'Function' => 'UpdateTo571'),
      571 => array('Revision' => 574, 'Function' => 'UpdateTo574'),
      574 => array('Revision' => 584, 'Function' => 'UpdateTo584'),
      584 => array('Revision' => 591, 'Function' => 'UpdateTo591'),
      591 => array('Revision' => 597, 'Function' => 'UpdateTo597'),
      597 => array('Revision' => 601, 'Function' => 'UpdateTo601'),
      601 => array('Revision' => 615, 'Function' => 'UpdateTo615'),
      615 => array('Revision' => 619, 'Function' => 'UpdateTo619'),
      619 => array('Revision' => 620, 'Function' => 'UpdateTo620'),
      620 => array('Revision' => 627, 'Function' => 'UpdateTo627'),
      627 => array('Revision' => 632, 'Function' => 'UpdateTo632'),
      632 => array('Revision' => 633, 'Function' => 'UpdateTo633'),
      633 => array('Revision' => 645, 'Function' => 'UpdateTo645'),
      645 => array('Revision' => 646, 'Function' => 'UpdateTo646'),
      646 => array('Revision' => 647, 'Function' => 'UpdateTo647'),
    ));
  }
}
